#include "Klasse.h"

int main() {

  const int MAX_ARR = 5;
  
  Person persArr[MAX_ARR];
/*
  for (int i = 0; i < MAX_ARR; i++) {
    cout << persArr[i].getNr() << ": " << persArr[i].getName() << endl;
  }
  persArr[0].setName("Miller"); 
  persArr[0].setNr(1);  
  persArr[1].setName("Bond"); 
  persArr[1].setNr(007);  
  for (int i = 0; i < MAX_ARR; i++) {
    cout << persArr[i].getNr() << ": " << persArr[i].getName() << endl;
  }

  // Ausgabe des Personen-Arrays wie oben mit for-Schleifen, jetzt aber mit
  // Funktion 'printPersArr()':
  printPersArr(persArr, MAX_ARR);



  // Untersuchung wieviel Zeit Objekt-Allozierungen auf Stack und Heap benoetigen:

  StatisticStopWatch stopWatch;
  const int MAX_LOOP = 5000000;


  // Allozierung auf dem Stack:
  stopWatch.reset();
  stopWatch.start();
  for (int i = 0; i < MAX_LOOP; i++) {
    Person pers(i, "John");
  }
  stopWatch.stop();
  stopWatch.printTime("Stack");


  // Allozierung auf dem Heap:
  stopWatch.reset();
  stopWatch.start();
  for (int i = 0; i < MAX_LOOP; i++) {
    Person* pers = new Person(i, "John");
  }
  stopWatch.stop();
  stopWatch.printTime("Heap: new()");
   
   
  // Tests mit 'inline-Methoden':
  int max_loop = 100 * MAX_LOOP;
  stopWatch.reset();
  stopWatch.start();
  Person pers;
  for (int i = 0; i < max_loop; i++) {
    pers.getNr();
  }
  stopWatch.stop();
  stopWatch.printTime("getNr()");
  stopWatch.reset();
  
  stopWatch.reset();
  stopWatch.start();
  for (int i = 0; i < max_loop; i++) {
    pers.getNrInline();
  }
  stopWatch.stop();
  stopWatch.printTime("getNrInline()");
  stopWatch.reset();
*/
}





/* Session-Log (Intel Pentium M / 1700 MHz; g++ 3.4.4):

$ make clean
rm -f Klasse.o KlasseTest.o StatisticStopWatch.o appl.exe

$ make all
g++  -g -c Klasse.cpp
g++  -g -c KlasseTest.cpp
g++  -g -c StatisticStopWatch.cpp
g++ -g -o appl.exe Klasse.o KlasseTest.o StatisticStopWatch.o

$ appl
-1:
-1:
-1:
-1:
-1:
1: Miller
7: Bond
-1:
-1:
-1:
1: Miller
7: Bond
-1:
-1:
-1:
Stack                =        218 ms
Heap: new()          =       7657 ms
getNr()              =       4140 ms
getNrInline()        =       1031 ms

$

*/

